// Copyright (c) 2002  Hitoshi Guutara Maruyama.
// This is free software;  for terms and warranty disclaimer see ./COPYING.

package jp.sourceforge.gnp.rulebase;

/* 롼١롼빽ǤΥ󥿡ե */

/**
 * @author   maruyama
 */
public interface ProrateRulebaseElement {

  public static final int	SPA_CODE = (256 + 1);
  public static final int	APD_P_CODE = (256 + 2);
  public static final int	VALIDITY_CODE = (256 + 3);
  public static final int	COMMON_CODE = (256 + 4);
  public static final int	ACTIONS_CODE = (256 + 5);
  public static final int	TAX_CODE = (256 + 6);
  public static final int	EXTF_CODE = (256 + 7);
  public static final int	PART_CODE = (256 + 8);
  public static final int	AND_CODE = (256 + 32 + 1);
  public static final int	OR_CODE	= (256 + 32 + 2);
  public static final int	SET_CODE = (256 + 32 + 3);
  public static final int	PERCENT_CODE = (256 + 32 + 4);
  public static final int	END_CODE = (256 + 32 + 5);
  public static final int	TEST_BEGIN_CODE = (256 + 32 + 6);
  public static final int	TEST_END_CODE = (256 + 32 + 7);
  public static final int	CASE_CODE = (256 + 32 + 8);
  public static final int	ENDCASE_CODE = (256 + 32 + 9);
  public static final int	CASE_BRANCH_BEGIN = (256 + 32 + 10);
  public static final int	CASE_BRANCH_END = (256 + 32 + 11);
  public static final int	TABLE_CODE = (256 + 32 + 12);
  public static final int	ENDTABLE_CODE = (256 + 32 + 13);
  public static final int	TABLE_FIELD_BEGIN = (256 + 32 + 14);
  public static final int	TABLE_FIELD_END = (256 + 32 + 15);
  public static final int	ATMARK_CODE = (256 + 32 + 16);
  public static final int	EQUAL_CODE = (256 + 32 + 17);
  public static final int	NEQ_CODE = (256 + 32 + 18);
  public static final int	STRINC_CODE = (256 + 32 + 19);
  public static final int	AUTO_CODE = (256 + 32 + 20);
  public static final int	RETURN_CODE = (256 + 32 + 21);
  public static final int	RETTRUE_CODE = (256 + 32 + 22);
  public static final int	RETFALSE_CODE = (256 + 32 + 23);
  public static final int	PATH_END_CODE = (256 + 32 + 24);
  public static final int	PARTCALL_CODE = (256 + 32 + 25);
  public static final int	MULTIVAL_CODE = (256 + 64 + 1);
  public static final int	INTERVAL_CODE = (256 + 64 + 2);
  public static final int	NUMBER_CODE = (512 + 1);
  public static final int	DATE_CODE = (512 + 2);
  public static final int	STRING_CODE = (512 + 4);
  public static final int	AMOUNT_CODE = (512 + 8);
  public static final int	PATH_CODE = (512 + 16);

  public static final int	VARIABLE_SPECIFICATION = 1024;

  public static final int	ENDORSE_VARIABLE = (1024 + 1);
  public static final int	RESTRICT_VARIABLE = (1024 + 2);
  public static final int	ORIGIN_VARIABLE = (1024 + 3);
  public static final int	DEST_VARIABLE = (1024 + 4);
  public static final int	ISSUE_DATE_VARIABLE = (1024 + 5);
  public static final int	ISSUE_BY_VARIABLE = (1024 + 6);
  public static final int	ISSUE_PLACE_VARIABLE = (1024 + 7);
  public static final int	MULTI_PATH_VARIABLE = (1024 + 8);
  public static final int	FC_FROM_VARIABLE = (1024 + 9);
  public static final int	FC_TO_VARIABLE = (1024 + 10);
  public static final int	FC_PATH_VARIABLE = (1024 + 11);
  public static final int	ISSUE_COUNTRY_VARIABLE = (1024 + 12);
  public static final int	ISSUE_AREA_VARIABLE = (1024 + 13);
  public static final int	ISSUE_AGENT_VARIABLE = (1024 + 14);
  public static final int	TOURCODE_VARIABLE = (1024 + 15);

  public static final int	PATH_VARIABLE_SPECIFICATION = (128);
  public static final int	FROM_VARIABLE = (1024 + 128 + 1);
  public static final int	TO_VARIABLE = (1024 + 128 + 2);
  public static final int	F_BASIS_VARIABLE = (1024 + 128 + 3);
  public static final int	TKDESIGN_VARIABLE = (1024 + 128 + 4);
  public static final int	F_BASIS_ALL_VARIABLE = (1024 + 128 + 5);
  public static final int	CARRIER_VARIABLE = (1024 + 128 + 6);
  public static final int	FLIGHT_VARIABLE = (1024 + 128 + 7);
  public static final int	CLASS_VARIABLE = (1024 + 128 + 8);
  public static final int	DATE_VARIABLE = (1024 + 128 + 9);
  public static final int	PATH_VARIABLE = (1024 + 128 + 10);
  public static final int	ROUTE_VARIABLE = (1024 + 128 + 11);

  public static final int	ANY_VARIABLE_SPECIFICATION = (64);
  public static final int	FROM_ANY_VARIABLE = (1024 + 128 + 64 + 1);
  public static final int	TO_ANY_VARIABLE = (1024 + 128 + 64 + 2);
  public static final int	F_BASIS_ANY_VARIABLE = (1024 + 128 + 64 + 3);
  public static final int	TKDESIGN_ANY_VARIABLE = (1024 + 128 + 64 + 4);
  public static final int	F_BASIS_ALL_ANY_VARIABLE = (1024 + 128 + 64 + 5);
  public static final int	CARRIER_ANY_VARIABLE = (1024 + 128 + 64 + 6);
  public static final int	FLIGHT_ANY_VARIABLE = (1024 + 128 + 64 + 7);
  public static final int	CLASS_ANY_VARIABLE = (1024 + 128 + 64 + 8);
  public static final int	DATE_ANY_VARIABLE = (1024 + 128 + 64 + 9);
  public static final int	PATH_ANY_VARIABLE = (1024 + 128 + 64 + 10);
  public static final int	ROUTE_ANY_VARIABLE = (1024 + 128 + 64 + 11);

  public static final int	SETTABLE_VARIABLE_SPECIFICATION	= (256);
  public static final int	DISCOUNT_VARIABLE = (1024 + 256 + 1);

  public static final int	AUTO_VARIABLE_SPECIFICATION = (1024 + 512);
  public static final int	AUTO_VARIABLE_INITIAL_CODE = (1024 + 512);

  public static final int	FUNCTION_SPECIFICATION = 2048;
  public static final int	EXTERNAL_FUNCTION = (2048 + 511);

  public static final int	Apply_apdp_FUNCTION = (2048 + 509);
  public static final int	Apply_spa_FUNCTION = (2048 + 510);

  public static final int	Pfm_FUNCTION = (2048 + 1);
  public static final int	Pfm_max_FUNCTION = (2048 + 2);
  public static final int	Srp_FUNCTION = (2048 + 3);
  public static final int	Np_FUNCTION = (2048 + 4);
  public static final int	Apply_discount_FUNCTION = (2048 + 5);
  public static final int	Country_FUNCTION = (2048 + 6);
  public static final int	Area_FUNCTION = (2048 + 7);
  public static final int	Route_FUNCTION = (2048 + 8);
  public static final int	Via_FUNCTION = (2048 + 9);
  public static final int	Via_country_FUNCTION = (2048 + 10);
  public static final int	Gateway_FUNCTION = (2048 + 11);
  public static final int	Gateway_country_FUNCTION = (2048 + 12);
  public static final int	RoundTheWorld_p_FUNCTION = (2048 + 13);
  public static final int	Mileage_p_FUNCTION = (2048 + 14);
  public static final int	Route_p_FUNCTION = (2048 + 15);
  public static final int	Sidetrip_p_FUNCTION = (2048 + 16);
  public static final int	No_amount_p_FUNCTION = (2048 + 17);
  public static final int	Special_fare_p_FUNCTION = (2048 + 18);
  public static final int	Promotional_fare_p_FUNCTION = (2048 + 19);
  public static final int	Normal_fare_p_FUNCTION = (2048 + 20);
  public static final int	Tax_divid_FUNCTION = (2048 + 21);
  public static final int	Via_area_FUNCTION = (2048 + 22);
  public static final int	Discount_FUNCTION = (2048 + 23);
  public static final int	Bi_proviso_FUNCTION = (2048 + 24);
  public static final int	Multipath_amt_FUNCTION = (2048 + 25);
  public static final int	Uncertain_FUNCTION = (2048 + 26);
  public static final int	Number_p_FUNCTION = (2048 + 27);
  public static final int	Date_p_FUNCTION = (2048 + 28);
  public static final int	String_p_FUNCTION = (2048 + 29);
  public static final int	Amount_p_FUNCTION = (2048 + 30);
  public static final int	Path_p_FUNCTION = (2048 + 31);
  public static final int	Error_FUNCTION = (2048 + 32);
  public static final int	Within_FUNCTION = (2048 + 33);
  public static final int	Within_country_FUNCTION = (2048 + 34);
  public static final int	Within_area_FUNCTION = (2048 + 35);
  public static final int	Intl_sector_p_FUNCTION = (2048 + 36);
  public static final int	Between_FUNCTION = (2048 + 37);
  public static final int	Between_country_FUNCTION = (2048 + 38);
  public static final int	Between_area_FUNCTION = (2048 + 39);
  public static final int	Between_PC_FUNCTION = (2048 + 40);
  public static final int	Between_PA_FUNCTION = (2048 + 41);
  public static final int	Between_CA_FUNCTION = (2048 + 42);
  public static final int	Exclusive_FUNCTION = (2048 + 43);
  public static final int	Another_FUNCTION = (2048 + 44);
  public static final int	High_spa_FUNCTION = (2048 + 45);
  public static final int	Low_spa_FUNCTION = (2048 + 46);
  public static final int	High_spa_fix_FUNCTION = (2048 + 47);
  public static final int	Low_spa_fix_FUNCTION = (2048 + 48);
  public static final int	Net_FUNCTION = (2048 + 49);
  public static final int	Srp_fix_FUNCTION = (2048 + 50);
  public static final int	Sia_FUNCTION = (2048 + 51);

  public static final int	COMMENT_CODE = 16384;

  public short	getRegist();
  public String	getName();
  /**
   * @return
   * @uml.property  name="comment"
   */
  public String	getComment();
  /**
   * @param comment
   * @uml.property  name="comment"
   */
  public void	setComment(String comment);
}
