// Copyright (c) 2002  Hitoshi Guutara Maruyama.
// This is free software;  for terms and warranty disclaimer see ./COPYING.

package jp.sourceforge.gnp.rulebase;

import jp.sourceforge.gnp.prubae.PrubaeModelAndOr;
import jp.sourceforge.gnp.prubae.PrubaeModelCase;
import jp.sourceforge.gnp.prubae.PrubaeModelDoStatement;
import jp.sourceforge.gnp.prubae.PrubaeModelFunction;
import jp.sourceforge.gnp.prubae.PrubaeModelIf;
import jp.sourceforge.gnp.prubae.PrubaeModelJudge;
import jp.sourceforge.gnp.prubae.PrubaeModelJudgeStatement;
import jp.sourceforge.gnp.prubae.PrubaeModelSwitch;
import jp.sourceforge.gnp.prubae.PrubaeModelTable;
import jp.sourceforge.gnp.prubae.PrubaeModelValue;
import jp.sourceforge.gnp.prubae.PrubaeModelValueStatement;

/* 롼١񤭽ФΥ󥿡ե */

public interface ProrateRulebaseWriter {
  public void write(ProrateRulebaseWriterElement model) throws ProrateRulebaseException;
  public void writeFunction(PrubaeModelFunction model);
  public void writeAndOr(PrubaeModelAndOr model);
  public void writeIf(PrubaeModelIf model);
  public void writeCase(PrubaeModelCase model);
  public void writeSwitch(PrubaeModelSwitch model);
  public void writeTable(PrubaeModelTable model);
  public void writeDoStatement(PrubaeModelDoStatement model);
  public void writeJudgeStatement(PrubaeModelJudgeStatement model);
  public void writeJudge(PrubaeModelJudge model);
  public void writeValueStatement(PrubaeModelValueStatement model);
  public void writeValue(PrubaeModelValue model);
  public int getFunctionSize(PrubaeModelFunction model);
  public int getAndOrSize(PrubaeModelAndOr model);
  public int getIfSize(PrubaeModelIf model);
  public int getCaseSize(PrubaeModelCase model);
  public int getSwitchSize(PrubaeModelSwitch model);
  public int getTableSize(PrubaeModelTable model);
  public int getDoStatementSize(PrubaeModelDoStatement model);
  public int getJudgeStatementSize(PrubaeModelJudgeStatement model);
  public int getValueStatementSize(PrubaeModelValueStatement model);
  public int getValueSize(PrubaeModelValue model);
}
